# Подключение внешних проектов
include(ExternalProject)

# cmake-format: off
list(APPEND _ext_project_args
  libpreprocmath
  SOURCE_DIR       ${CMAKE_SOURCE_DIR}/thirdparty/libpreprocmath
  INSTALL_DIR      ${CMAKE_BINARY_DIR}
  BUILD_BYPRODUCTS ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/libpreprocmath.a
  CMAKE_ARGS       ${CMLIB_EXT_PROJ_DEFAULT_ARGS}
                   <SOURCE_DIR>)
if(PreprocmathThirdparty_FIND_COMPONENTS STREQUAL "headers")
  list(APPEND _ext_project_args
    BUILD_COMMAND     true
    INSTALL_COMMAND   ${CMAKE_MAKE_PROGRAM} preprocmath-install-headers)
endif()
ExternalProject_Add(${_ext_project_args})
unset(_ext_project_args)

set(PREPROCMATH_IS_EXTERNAL_PROJECT ON CACHE BOOL "" FORCE)
# cmake-format: on

set(PREPROCMATH_PREFIX
    ${CMAKE_BINARY_DIR}
    CACHE FILEPATH "" FORCE)
set(PREPROCMATH_INCLUDE_DIR
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}
    CACHE PATH "" FORCE)
set(PREPROCMATH_INCLUDE_DIRS
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}
    CACHE PATH "" FORCE)
set(PREPROCMATH_LIBRARY_DIR
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}
    CACHE PATH "" FORCE)
set(PREPROCMATH_LIBRARIES
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/libpreprocmath.a
    CACHE FILEPATH "" FORCE)
